/*global define*/

define([
    'parse',
    'models/Todo'
], function (Parse, Todo) {
    'use strict';

    var TodoList = Parse.Collection.extend({

        // Reference to this collection's model.
        model: Todo,

        // We keep the Todos in sequential order, despite being saved by unordered
        // GUID in the database. This generates the next order number for new items.
        nextOrder: function() {
            if (!this.length) return 1;
            return this.last().get('order') + 1;
        },

        // Todos are sorted by their original insertion order.
        comparator: function(todo) {
            return todo.get('order');
        }

    });

    return TodoList;
});
