//Definim les dependencies mitjançant require.js

define([
    'jquery', 
    'underscore', 
    'Backbone', 
    'parse', 
    'barcode',
    'collections/ClientReservaList',
    'models/ClientReserva',
    'models/Client',
    'models/Reserva',
    'models/Hotel',
    'text!templates/CodiBarres/CodiBarresView.tpl' 
    ], function ($, _, Backbone, Parse, Barcode, ClientReservaList, ClientReserva, Client, Reserva, Hotel, CodiBarresViewTemplate) {
        return Backbone.View.extend({

            template:_.template(CodiBarresViewTemplate),

            $clientPerImprimir:null,

            // Events a la pantalla i respectives funcions que els atendran
	    
            events: {
              'pageshow':'pageShow',
              'click #menu': 'popUp'
            },


            render: function() {
	      
		// Dibuixam la pantalla mitjançant la plantilla HTML

                this.$el.html(this.template());
		
		// I després es dibuixen els element que la forman, en aquest cas:
		//	Codi de CodiBarres
		//	Identificació del client usuari

                this.$clientPerImprimir = this.$('#dades-client');
                $("#bcTarget").barcode(Parse.User.current().escape("username"), "ean13",{barWidth:2, barHeight:200});

                return this;

            },

	    // Crida al menu emergent de la aplicació
	    
            popUp: function(event) {
                $("#pop").popup("open");
            },

	    // Funció que controla la correcte generació del llistat que apareix en pantalla
            pageShow:function (event) {
                if (!this.paginaPintada) {
                    this.paginaPintada = true;

                    var that = this;
                    _.defer(function () {
                        that.imprimirClient();
                    });
                }
            },
	    
	    // Definició del llistat on apareixeran les dades del client
	    // generat mitjançant una serie de consultes de la BBDD a parse.com

            imprimirClient:function() {

                var that = this;

                $.mobile.showPageLoadingMsg('a', 'Carregant identificació del usuari');
		
		//Primera consulta que localitza el nostre usuari a la entitat 'ClientReserva'

                consulta = new Parse.Query(ClientReserva);

                consulta.include('client');
                consulta.include('reserva.hotel');
                consulta.equalTo('usuari', Parse.User.current());

                consulta.first({
                    success:function (usuari) {

                        $.mobile.hidePageLoadingMsg();

                        var items = [];

                        console.log('Les notes del client son ' + usuari.get('Notes'));
                        console.log('Client Reserva ' + Parse.User.current().get('username'));


                        //Imprimim el nom del usuari
                        var client = new Client();
			
                        var client = usuari.get('client');
                        var $item1 = $('<li> ' + client.escape('Nom') + ' ' + client.escape('Cognoms') +' </li>');
                        console.log('el client es ' + client.get('Nom'));
                        items.push($item1[0]);

                        //Imprimim l'hotel on s'ha enregistrat
                        that.reserva = new Reserva();
                        that.hotel = new Hotel();
			
                        that.reserva = usuari.get('reserva');
                        that.hotel = that.reserva.get('hotel');
                        var $item2 = $('<li> ' + that.hotel.escape('Nom') + ' </li>');
                        console.log('Lhotel  es ' + that.hotel.get('Nom'));
                        items.push($item2[0]);
                    
                        that.$clientPerImprimir.html(items).listview('refresh');

                    }, error:function (error) {
                        $.mobile.hidePageLoadingMsg();
                        alert("Error en la identificació");
                    }
                });
                

            }


        });
    });