//Definim les dependencies mitjançant require.js

define([
    'jquery',
    'underscore',
    'Backbone',
    'parse',
    'views/Home/HomeView',
    'text!templates/Home/LogInView.tpl'
], function ($, _, Backbone, Parse, HomeView, LogInTemplate) {
    'use strict';

    var LoginView = Backbone.View.extend({

        template: _.template(LogInTemplate),

        transition: $.mobile.defaultPageTransition,
	
	// Events a la pantalla i respectives funcions que els atendran

        events: {
            'submit form.login-form': 'logIn'
        },

	//Iniciem vista
        initialize: function() {
            this.render();
        },
	
	// Funció que controla la correcte entrada de credencials al sistema

        logIn: function(e) {
	  
	  //Recollim el valor dels camps del formulari
            var self = this;
            var username = this.$('#login-username').val();
            var password = this.$('#login-password').val();

            Parse.User.logIn(username, password, {
                success: function(user) {
		  //Si les credencials pertanyen a un usuari, entre a la aplicació (vista Home)
                    $.mobile.jqmNavigator.pushView(new HomeView(), {transition: this.transition});
                    self.undelegateEvents();
                },

                error: function(user, error) {
                    self.$('.login-form .error').html('Codi reserva o codi usuari incorrectes. Torni a provar. ').show();
                    self.$('.login-form button').removeAttr('disabled');
                }
            });

            this.$('.login-form button').attr('disabled', 'disabled');

            return false;
        },


        render: function() {
	  // Dibuixam la pantalla mitjançant la plantilla HTML
            this.$el.html(this.template());
        }
    });

    return LoginView;
});
