//Definim les dependencies mitjançant require.js

define(['jquery', 
    'underscore', 
    'Backbone', 
    'models/ClientReserva',
    'models/ReservaPromocio',
    'models/Promocio',
    'views/LlistatPromocions/CancelacioReservaView',
    'text!templates/LlistatPromocions/LlistatReservesView.tpl','jqm'],
    function ($, _, Backbone, ClientReserva, ReservaPromocio, Promocio, CancelacioReservaView, LlistatReservesViewTemplate) {
        return Backbone.View.extend({

            $reservesPerImprimir:null,

            template:_.template(LlistatReservesViewTemplate),

	    // Events a la pantalla i respectives funcions que els atendran
            events: {
                'click #menu': 'popUp',
                'click #llista-reserves li': 'accesReserva',
                'pageshow':'pageShow'
            },


            render:function () {
	      // Dibuixam la pantalla mitjançant la plantilla HTML
                this.$el.html(this.template());
		
		// I després es dibuixen els element que la forman, en aquest cas:
		//	Llistat de reserves
                this.$reservesPerImprimir = this.$('#llista-reserves');
                return this;
            },


	    // Crida al menu emergent de la aplicació
            popUp: function(e) {
                $("#pop").popup("open");
            },

	    // Funció que controla la correcte generació del llistat que apareix en pantalla
            pageShow:function (event) {

                var that = this;
                _.defer(function () {
                    that.imprimirReserves();
                });

            },

    	    // Definició del llistat de promocions reservades del hotel
	       // generat mitjançant una serie de consultes de la BBDD a parse.com
            imprimirReserves:function() {

                var that = this;

                $.mobile.showPageLoadingMsg('a', 'Carregant promocions reservades');
		
		          //Primera consulta que localitza el nostre usuari a la entitat 'ClientReserva'

                promocionsReservadesClient = new Parse.Query(ReservaPromocio);
                promocionsReservadesClient.include('promocio');
                promocionsReservadesClient.equalTo('usuari', Parse.User.current());

                that.promocio = new Promocio();

                promocionsReservadesClient.find({
                    success:function (LlistaReserves){

                        $.mobile.hidePageLoadingMsg();

			             //Llistam llista de reserves assignada a l'usuari
                        var items = [];
                        var n = 0;

                        _.each(LlistaReserves, function (reserva){

                            that.promocio = reserva.get('promocio');
                            that.promocio.set('reserva', reserva);
                            console.log('Imprimir promocio ' + that.promocio.get('Nom'));


                            var $item = $('<li id= "'
                                + n
                                +'"> <h3>' 
                                + that.promocio.escape('Nom')
                                + '</h3> </li>').jqmData('promocio',that.promocio);

                            n= n+1;
                            items.push($item[0]);

                        }, that);

                        that.$reservesPerImprimir.html(items).listview('refresh');

                            

                    },error:function (error) {
                        $.mobile.hidePageLoadingMsg();
                        alert("Error en el llistat de reserves");
                    }
                });


            },

	    // Obrim la reserva de promocio seleccionada i enviam el seu model com a paràmetre
            accesReserva:function (event){
                var promo = new Promocio();
                promo = $(event.currentTarget).jqmData('promocio'); 
                console.log('La reserva a visualitzar es ' + promo.get('Nom'));
                $.mobile.jqmNavigator.pushView(new CancelacioReservaView({model:promo}));
            }

        });
    });