//Definim les dependencies mitjançant require.js

define(['jquery', 
    'underscore', 
    'Backbone',
    'models/ReservaPromocio',
    'views/LlistatPromocions/LlistatReservesView',
    'text!templates/LlistatPromocions/ReservaPromocioView.tpl'],
    function ($, _, Backbone, ReservaPromocio, LlistatReservesView, ReservaPromocioViewTemplate) {
        return Backbone.View.extend({


	       // Events a la pantalla i respectives funcions que els atendran
            events: {
                "click #back": "btnBack",
                'click #btReservar': 'popUp',
                'click #desfer': 'tancaPopUp',
                'click #confirmar': 'confirmaReserva',
                'click #ok': 'tancaVistaReserva'
            },
	    
	        //Funció jqmNavigator que treu la vista de la pila i torna control al router Backbone
	        btnBack:function (event) {
                $.mobile.jqmNavigator.popView();
                //$.mobile.jqmNavigator.replaceView(new LlistatPromocionsView());
            },

            // Crida al menu emergent de confirmació de la reserva
            popUp: function(e) {
                $("#reserva").popup("open");
            },

            // Tancam el menu emergent de confirmació de la reserva
            tancaPopUp: function(e) {
                $("#reserva").popup("close");
            },

            // Confirmam definitivament la reserva
            confirmaReserva: function(e){
                $("#reserva").popup("close");

                var reserva = new ReservaPromocio();

                reserva.save({
                    nPersones: parseInt($('#nPersones').val()),
                    usuari: Parse.User.current(),
                    promocio: this.model,
                    }, {
                    success: function(gameTurnAgain) {
                        $("#confirmacio").popup("open");
                    },
                    error: function(gameTurnAgain, error) {
                        alert("Error al confirmar la reserva");
                    }
                });
                
            },

            tancaVistaReserva:function(e){
                $("#confirmacio").popup("close");
                $.mobile.jqmNavigator.popView();
            },

	    
            render:function () {
	        // Dibuixam la pantalla mitjançant la plantilla HTML passant el model com a paràmetre
                console.log('La promoció visualiltzada es ' + this.model.get('Nom'));
                this.$el.html(_.template(ReservaPromocioViewTemplate, {promocio:this.model}));
                return this;
            }

        });
    });