//Definim les dependencies mitjançant require.js

define(['jquery', 
    'underscore', 
    'Backbone', 
    'models/ClientReserva',
    'models/Reserva',
    'models/Hotel',
    'models/Servei',
    'views/LlistatHotel/SeccioHotelView',
    'text!templates/LlistatHotel/LlistatEquipamentView.tpl','jqm'],
    function ($, _, Backbone, ClientReserva, Reserva, Hotel, Servei, SeccioHotelView,LlistatEquipamentViewTemplate) {
        return Backbone.View.extend({

            $equipamentPerImprimir:null,

            template:_.template(LlistatEquipamentViewTemplate),
				    
	    // Events a la pantalla i respectives funcions que els atendran

            events: {
                'click #menu': 'popUp',
                'click #llista-equipament li': 'accesEquipament',
                'pageshow':'pageShow'
            },


            render:function () {
	      // Dibuixam la pantalla mitjançant la plantilla HTML
                this.$el.html(this.template());
		// I després es dibuixen els element que la forman, en aquest cas:


		//	Llistat d'equipament
                this.$equipamentPerImprimir = this.$('#llista-equipament');
                return this;
            },

	    // Crida al menu emergent de la aplicació
            popUp: function(e) {
                $("#pop").popup("open");
            },

	    // Funció que controla la correcte generació del llistat que apareix en pantalla
            pageShow:function (event) {
                if (!this.paginaPintada) {
                    this.paginaPintada = true;

                    var that = this;
                    _.defer(function () {
                        that.imprimirLlistaEquipament();
                    });
                }
            },
	    
	    // Definició del llistat d'equipament del hotel
	    // generat mitjançant una serie de consultes de la BBDD a parse.com

            imprimirLlistaEquipament:function() {

                var that = this;
                var items = [];

                $.mobile.showPageLoadingMsg('a', 'Carregant llista de equipament del hotel');
		
		//Primera consulta que localitza el nostre usuari a la entitat 'ClientReserva'

                hotelClient = new Parse.Query(ClientReserva);
                hotelClient.include('reserva.hotel');
                hotelClient.equalTo('usuari', Parse.User.current());

                that.reserva = new Reserva();
                that.hotel = new Hotel();


                hotelClient.first({
                    success:function (usuari) {

                        console.log('El codi del usuari es el ' + Parse.User.current().get('username'));

                        //Consulta que llista l'equipament que pertany a l'hotel de l'usuari
                        
                        that.reserva = usuari.get('reserva');
                        that.hotel = that.reserva.get('hotel');

                        console.log('Lhotel  es ' + that.hotel.get('Nom'));


                        serveisHotelUsuari = new Parse.Query(Servei);
                        serveisHotelUsuari.include('hotel');
                        serveisHotelUsuari.equalTo('hotel', that.hotel);
                        serveisHotelUsuari.equalTo('Tipus','Equipament');

                        serveisHotelUsuari.find({
                            success:function (LlistaEquipament){

                                $.mobile.hidePageLoadingMsg();

                                var items = [];
                                var n = 0;

                                _.each(LlistaEquipament, function (servei){

                                    console.log('Imprimir instalacio ' + servei.get('Nom'));

                                    var $item = $('<li id= "'
                                        + n
                                        +'"> <h3>' 
                                        + servei.escape('Nom')
                                        + '</h3> </li>').jqmData('servei',servei);

                                    n= n+1;
                                    items.push($item[0]);

                                }, that);

                                that.$equipamentPerImprimir.html(items).listview('refresh');

                            },error:function (error) {
                                $.mobile.hidePageLoadingMsg();
                                alert("Error en el llistat d'instalacions");
                            }
                        });


                    }, error:function (error) {
                        $.mobile.hidePageLoadingMsg();
                        alert("Usuari mal registrat. No existeix client assignat.");
                    }
                });


            },
	    
	    // Obrim la secció d'hotel seleccionada i enviam el seu model com a paràmetre

            accesEquipament:function (event){
                var instalacio= new Servei();
                instalacio = $(event.currentTarget).jqmData('servei'); 
                $.mobile.jqmNavigator.pushView(new SeccioHotelView({model:instalacio}));
            }

        });
    });