//Definim les dependencies mitjançant require.js

define(['jquery', 
    'underscore', 
    'Backbone', 
    'models/ClientReserva',
    'models/Reserva',
    'models/Hotel',
    'models/Servei',
    'views/LlistatHotel/SeccioHotelView',
    'text!templates/LlistatHotel/LlistatHotelView.tpl','jqm'],
    function ($, _, Backbone, ClientReserva, Reserva, Hotel, Servei, SeccioHotelView,LlistatHotelViewTemplate) {
        return Backbone.View.extend({

            $serveisPerImprimir:null,

            template:_.template(LlistatHotelViewTemplate),
				    
	    // Events a la pantalla i respectives funcions que els atendran

            events: {
	      	'click #menu': 'popUp',
                'click #llista-serveis li': 'accesActivitat',
                'pageshow':'pageShow'
	    	},


            render:function () {
		// Dibuixam la pantalla mitjançant la plantilla HTML
                this.$el.html(this.template());
		
		// I després es dibuixen els element que la forman, en aquest cas:



		//	Llistat de serveis
                this.$serveisPerImprimir = this.$('#llista-serveis');
                return this;
            },


	    // Crida al menu emergent de la aplicació
	    	popUp: function(e) {
	      		$("#pop").popup("open");
	    	},


	    // Funció que controla la correcte generació del llistat que apareix en pantalla
            pageShow:function (event) {
                if (!this.paginaPintada) {
                    this.paginaPintada = true;

                    var that = this;
                    _.defer(function () {
                        that.imprimirServeis();
                    });
                }
            },
	  
    	    // Definició del llistat de serveis del hotel

	    // generat mitjançant una serie de consultes de la BBDD a parse.com

            imprimirServeis:function() {

                var that = this;
                var items = [];

                $.mobile.showPageLoadingMsg('a', 'Carregant activitats del hotel');
		
		//Primera consulta que localitza el nostre usuari a la entitat 'ClientReserva'


                hotelClient = new Parse.Query(ClientReserva);
                hotelClient.include('reserva.hotel');
                hotelClient.equalTo('usuari', Parse.User.current());

                that.reserva = new Reserva();
                that.hotel = new Hotel();


                hotelClient.first({
                    success:function (usuari) {

                        console.log('El codi del usuari es el ' + Parse.User.current().get('username'));

                        ////Consulta que llista els serveis que pertanyen a l'hotel de l'usuari
                        
                        that.reserva = usuari.get('reserva');
                        that.hotel = that.reserva.get('hotel');

                        console.log('Lhotel  es ' + that.hotel.get('Nom'));


                        serveisHotelUsuari = new Parse.Query(Servei);
                        serveisHotelUsuari.include('hotel');
                        serveisHotelUsuari.equalTo('hotel', that.hotel);
                        serveisHotelUsuari.equalTo('Tipus','Activitat');

                        serveisHotelUsuari.find({
                            success:function (LlistaActivitats){

                                $.mobile.hidePageLoadingMsg();

                                var items = [];
                                var n = 0;

                                _.each(LlistaActivitats, function (servei){

                                    console.log('Imprimir activitat ' + servei.get('Nom'));

                                    var $item = $('<li id= "'
                                        + n
                                        +'"> <h3>' 
                                        + servei.escape('Nom')
                                        + '</h3> </li>').jqmData('servei',servei);

                                    n= n+1;
                                    items.push($item[0]);

                                }, that);

                                that.$serveisPerImprimir.html(items).listview('refresh');

                            },error:function (error) {
                                $.mobile.hidePageLoadingMsg();
                                alert("Error en el llistat de serveis");
                            }
                        });


                    }, error:function (error) {
                        $.mobile.hidePageLoadingMsg();
                        alert("Usuari mal registrat. No existeix client assignat.");
                    }
                });


            },

	    // Obrim la secció d'hotel seleccionada i enviam el seu model com a paràmetre
            accesActivitat:function (event){
                var activitat = new Servei();
                activitat = $(event.currentTarget).jqmData('servei'); 
                $.mobile.jqmNavigator.pushView(new SeccioHotelView({model:activitat}));
            }

        });
    });