//Definim les dependencies mitjançant require.js

define(['jquery', 
    'underscore', 
    'Backbone', 
    'models/ClientReserva',
    'models/Reserva',
    'models/Hotel',
    'models/Servei',
    'views/LlistatHotel/SeccioHotelView',
    'text!templates/LlistatHotel/LlistatRestaurantsView.tpl','jqm'],
    function ($, _, Backbone, ClientReserva, Reserva, Hotel, Servei, SeccioHotelView,LlistatRestaurantsViewTemplate) {
        return Backbone.View.extend({

            $restaurantsPerImprimir:null,

            template:_.template(LlistatRestaurantsViewTemplate),

	    // Events a la pantalla i respectives funcions que els atendran
            events: {
                'click #menu': 'popUp',
                'click #llista-restaurants li': 'accesRestaurant',
                'pageshow':'pageShow'
            },


            render:function () {
	      // Dibuixam la pantalla mitjançant la plantilla HTML
                this.$el.html(this.template());
		
		// I després es dibuixen els element que la forman, en aquest cas:



		//	Llistat de restaurants
                this.$restaurantsPerImprimir = this.$('#llista-restaurants');
                return this;
            },


	    // Crida al menu emergent de la aplicació
            popUp: function(e) {
                $("#pop").popup("open");
            },


	    // Funció que controla la correcte generació del llistat que apareix en pantalla
            pageShow:function (event) {
                if (!this.paginaPintada) {
                    this.paginaPintada = true;

                    var that = this;
                    _.defer(function () {
                        that.imprimirLlistaRestaurants();
                    });
                }
            },
	    
	    // Definició del llistat de restaurants del hotel

	    // generat mitjançant una serie de consultes de la BBDD a parse.com
            imprimirLlistaRestaurants:function() {

                var that = this;
                var items = [];

                $.mobile.showPageLoadingMsg('a', 'Carregant llista de restaurants del hotel');
		
		//Primera consulta que localitza el nostre usuari a la entitat 'ClientReserva'

                hotelClient = new Parse.Query(ClientReserva);
                hotelClient.include('reserva.hotel');
                hotelClient.equalTo('usuari', Parse.User.current());

                that.reserva = new Reserva();
                that.hotel = new Hotel();


                hotelClient.first({
                    success:function (usuari) {

                        console.log('El codi del usuari es el ' + Parse.User.current().get('username'));

                        //Consulta que llista els restaurants que pertanyen a l'hotel de l'usuari
                        
                        that.reserva = usuari.get('reserva');
                        that.hotel = that.reserva.get('hotel');

                        console.log('Lhotel  es ' + that.hotel.get('Nom'));


                        serveisHotelUsuari = new Parse.Query(Servei);
                        serveisHotelUsuari.include('hotel');
                        serveisHotelUsuari.equalTo('hotel', that.hotel);
                        serveisHotelUsuari.equalTo('Tipus','Restaurant');

                        serveisHotelUsuari.find({
                            success:function (LlistaRestaurants){

                                $.mobile.hidePageLoadingMsg();

                                var items = [];
                                var n = 0;

                                _.each(LlistaRestaurants, function (servei){

                                    console.log('Imprimir restaurant ' + servei.get('Nom'));

                                    var $item = $('<li id= "'
                                        + n
                                        +'"> <h3>' 
                                        + servei.escape('Nom')
                                        + '</h3> </li>').jqmData('servei',servei);

                                    n= n+1;
                                    items.push($item[0]);

                                }, that);

                                that.$restaurantsPerImprimir.html(items).listview('refresh');

                            },error:function (error) {
                                $.mobile.hidePageLoadingMsg();
                                alert("Error en el llistat de restaurants");
                            }
                        });


                    }, error:function (error) {
                        $.mobile.hidePageLoadingMsg();
                        alert("Usuari mal registrat. No existeix client assignat.");
                    }
                });


            },

	    // Obrim la secció d'hotel seleccionada i enviam el seu model com a paràmetre
            accesRestaurant:function (event){
                var restaurant= new Servei();
                restaurant = $(event.currentTarget).jqmData('servei'); 
                $.mobile.jqmNavigator.pushView(new SeccioHotelView({model:restaurant}));
            }

        });
    });