//Definim les dependencies mitjançant require.js

define(['jquery', 
    'underscore', 
    'Backbone', 
    'text!templates/LlistatPromocions/CancelacioReservaView.tpl'],
    function ($, _, Backbone, CancelacioReservaViewTemplate) {
        return Backbone.View.extend({


	       // Events a la pantalla i respectives funcions que els atendran
            events: {
                "click #back": "btnBack",
                'click #cancelar': 'popUp',
                'click #desfer': 'tancaPopUp',
                'click #confirmar': 'cancelaReserva',
                'click #ok': 'tancaVistaCancelacio'
            },

	       //Funció jqmNavigator que treu la vista de la pila i torna control al router Backbone
	       btnBack:function (event) {
                $.mobile.jqmNavigator.popView();
                //$.mobile.jqmNavigator.replaceView(new LlistatReservesView());
            },

            // Crida al menu emergent de cancelació de la reserva
            popUp: function(e) {
                $("#cancelacio").popup("open");
            },

            // Tancam el menu emergent de cancelació de la reserva
            tancaPopUp: function(e) {
                $("#cancelacio").popup("close");
            },

            // Eliminam definitivament la reserva
            cancelaReserva: function(e){
                $("#cancelacio").popup("close");
                this.model.get('reserva').destroy({
                    success: function() {
                        $("#confirmacio").popup("open");
                    },
                    error: function(error) {
                        alert("Error al cancelar la reserva");
                    }
                });
                
            },

            tancaVistaCancelacio:function(e){
                $("#confirmacio").popup("close");
                $.mobile.jqmNavigator.popView();
            },

            render:function () {
	      // Dibuixam la pantalla mitjançant la plantilla HTML passant el model com a paràmetre
                console.log('La reserva visualiltzada es ' + this.model.get('Nom'));
                this.$el.html(_.template(CancelacioReservaViewTemplate, {promocio:this.model}));
                return this;
            }

        });
    });