//Definim les dependencies mitjançant require.js

define(['jquery', 
    'underscore', 
    'Backbone', 
    'models/ClientReserva',
    'models/Reserva',
    'models/Hotel',
    'models/Promocio',
    'views/LlistatPromocions/ReservaPromocioView',
    'text!templates/LlistatPromocions/LlistatPromocionsView.tpl','jqm'],
    function ($, _, Backbone, ClientReserva, Reserva, Hotel, Promocio, ReservaPromocioView, LlistatPromocionsViewTemplate) {
        return Backbone.View.extend({

            $promocionsPerImprimir:null,

            template:_.template(LlistatPromocionsViewTemplate),

	    // Events a la pantalla i respectives funcions que els atendran
            events: {
	      		'click #menu': 'popUp',
                'click #llista-promocions li': 'accesPromocio',
                'pageshow':'pageShow'
	    	},


            render:function () {
	      // Dibuixam la pantalla mitjançant la plantilla HTML
                this.$el.html(this.template());
		
		// I després es dibuixen els element que la forman, en aquest cas:


		//	Llistat de promocions
                this.$promocionsPerImprimir = this.$('#llista-promocions');
                return this;
            },


	     // Crida al menu emergent de la aplicació
	    	popUp: function(e) {
	      		$("#pop").popup("open");
	    	},


	  // Funció que controla la correcte generació del llistat que apareix en pantalla
            pageShow:function (event) {
                if (!this.paginaPintada) {
                    this.paginaPintada = true;

                    var that = this;
                    _.defer(function () {
                        that.imprimirPromocions();
                    });
                }
            },
	    
	    // Definició del llistat de promocions del hotel
	    // generat mitjançant una serie de consultes de la BBDD a parse.com
            imprimirPromocions:function() {

                var that = this;

                $.mobile.showPageLoadingMsg('a', 'Carregant promocions actives del hotel');

		//Primera consulta que localitza el nostre usuari a la entitat 'ClientReserva'

                hotelClient = new Parse.Query(ClientReserva);
                hotelClient.include('reserva.hotel');
                hotelClient.equalTo('usuari', Parse.User.current());

                that.reserva = new Reserva();
                that.hotel = new Hotel();
                that.promocio = new Promocio();


                hotelClient.first({
                    success:function (usuari) {

                        console.log('El codi del usuari es el ' + Parse.User.current().get('username'));

                        //Consulta que llista les promocions que pertanyen a l'hotel de l'usuari
                        
                        that.reserva = usuari.get('reserva');
                        that.hotel = that.reserva.get('hotel');

                        console.log('Lhotel  es ' + that.hotel.get('Nom'));


                        promocionsHotelUsuari = new Parse.Query(Promocio);
                        promocionsHotelUsuari.include('hotel');
                        promocionsHotelUsuari.equalTo('hotel', that.hotel);

                        promocionsHotelUsuari.find({
                            success:function (LlistaPromocions){

                                $.mobile.hidePageLoadingMsg();

                                var items = [];
                                var n = 0;

                                _.each(LlistaPromocions, function (promocio){

                                    console.log('Imprimir promocio ' + promocio.get('Nom'));

                                    var $item = $('<li id= "'
                                        + n
                                        +'"> <h3>' 
                                        + promocio.escape('Nom')
                                        + '</h3> </li>').jqmData('promocio',promocio);

                                    n= n+1;
                                    items.push($item[0]);

                                }, that);

                                that.$promocionsPerImprimir.html(items).listview('refresh');

                            

                            },error:function (error) {
                                $.mobile.hidePageLoadingMsg();
                                alert("Error en el llistat de promocions");
                            }
                        });


                    }, error:function (error) {
                        $.mobile.hidePageLoadingMsg();
                        alert("Usuari mal registrat. No existeix client assignat.");
                    }
                });


            },

	    // Obrim la promoció del hotel seleccionada i enviam el seu model com a paràmetre
            accesPromocio:function (event){
                var promo = new Promocio();
                promo = $(event.currentTarget).jqmData('promocio'); 
                console.log('La promocio a parametritzar es ' + promo.get('Nom'));
                $.mobile.jqmNavigator.pushView(new ReservaPromocioView({model:promo}));
            }

        });
    });