define(['jquery', 
    'underscore', 
    'Backbone', 
    'models/ClientReserva',
    'models/Reserva',
    'models/Hotel',
    'models/Servei',
    'models/Promocio',
    'views/LlistatPromocions/ReservaPromocioView',
    'text!templates/LlistatPromocions/LlistatPromocionsView.tpl','jqm'],
    function ($, _, Backbone, ClientReserva, Reserva, Hotel, Servei, Promocio, ReservaPromocioView, LlistatPromocionsViewTemplate) {
        return Backbone.View.extend({

            $promocionsPerImprimir:null,

            items: [],

            template:_.template(LlistatPromocionsViewTemplate),

            events: {
	      		'click #menu': 'popUp',
                'click #llista-promocions li': 'accesPromocio',
                'pageshow':'pageShow'
	    	},


            render:function () {
                this.$el.html(this.template());
                this.$promocionsPerImprimir = this.$('#llista-promocions');
                return this;
            },


	    	popUp: function(e) {
	      		$("#pop").popup("open");
	    	},


            pageShow:function (event) {
                if (!this.paginaPintada) {
                    this.paginaPintada = true;

                    var that = this;
                    _.defer(function () {
                        that.imprimirPromocions();
                        that.$promocionsPerImprimir.html(that.items).listview('refresh');
                    });
                }
            },

            imprimirPromocions:function() {

                var that = this;
                that.items = [];

                $.mobile.showPageLoadingMsg('a', 'Carregant promocions actives del hotel');


                hotelClient = new Parse.Query(ClientReserva);
                hotelClient.include('reserva.hotel');
                hotelClient.equalTo('usuari', Parse.User.current());

                that.reserva = new Reserva();
                that.hotel = new Hotel();
                that.promocio = new Promocio();


                hotelClient.first({
                    success:function (usuari) {

                        console.log('El codi del usuari es el ' + Parse.User.current().get('username'));

                        //Seleccionem l'hotel on s'ha enregistrat per saber els seus serveis
                        
                        that.reserva = usuari.get('reserva');
                        that.hotel = that.reserva.get('hotel');
                        var items = [];

                        console.log('Lhotel  es ' + that.hotel.get('Nom'));


                        serveisHotelUsuari = new Parse.Query(Servei);
                        serveisHotelUsuari.include('hotel');
                        serveisHotelUsuari.equalTo('hotel', that.hotel);

                        serveisHotelUsuari.find({
                            success:function (LlistaServeis){

                                $.mobile.hidePageLoadingMsg();

                                var n = 0;

                                _.each(LlistaServeis, function (servei){


                                    promocionsServeiHotel = new Parse.Query(Promocio);
                                    promocionsServeiHotel.include('servei');
                                    promocionsServeiHotel.equalTo('servei',servei);

                                    promocionsServeiHotel.find({
                                        success:function (LlistaPromocions){

                                            $.mobile.hidePageLoadingMsg();

                                            
                                            console.log('Promocions del servei ' + servei.get('Nom'));

                                            _.each(LlistaPromocions, function (promocio){

                                                console.log('    Imprimir promocio ' + promocio.get('Nom'));
                                                that.promocio = promocio;

                                                var $item = $('<li id= "'
                                                    + n
                                                    +'"> <h3>' 
                                                    + that.promocio.escape('Nom')
                                                    + '</h3> </li>').jqmData('promocio',that.promocio);

                                                n= n+1;
                                                that.items.push($item[0]);
                                            }, that);

                                            that.$promocionsPerImprimir.html(that.items).listview('refresh');
                                            
                                        },error:function (error) {
                                            $.mobile.hidePageLoadingMsg();
                                            console.log('No existeixen promocions del servei ' + servei.get('Nom'));
                                        }
                                    });

                                }, that);

                                //that.$promocionsPerImprimir.html(that.items).listview('refresh');
                            

                            },error:function (error) {
                                $.mobile.hidePageLoadingMsg();
                                alert("No existeix cap servei al hotel");
                            }
                        });


                    }, error:function (error) {
                        $.mobile.hidePageLoadingMsg();
                        alert("Usuari mal registrat. No existeix client assignat.");
                    }
                });


            },

            accesPromocio:function (event){
                var promo = new Promocio();
                promo = $(event.currentTarget).jqmData('promocio'); 
                console.log('La promocio a parametritzar es ' + promo.get('Nom'));
//                $.mobile.jqmNavigator.pushView(new ReservaPromocioView({model:promo}));
            }

        });
    });