//Definim les dependencies mitjançant require.js

define(['jquery', 'underscore', 'Backbone', 'text!templates/RssFeedReader/RssFeedReaderView.tpl','jqm'],
    function ($, _, Backbone, RssFeedReaderViewTemplate) {
        return Backbone.View.extend({

            template:_.template(RssFeedReaderViewTemplate),

            $feedsPerImprimir:null,


            blogdata: [],


            // Events a la pantalla i respectives funcions que els atendran

            events: {
              'pageshow':'pageShow',
              'click #menu': 'popUp'
            },



            render:function () {
	      // Dibuixam la pantalla mitjançant la plantilla HTML
                this.$el.html(this.template());
		
		// I després es dibuixen els element que la forman, en aquest cas:

		//	Llistat de noticies
                this.$feedsPerImprimir = this.$('#llista-feeds');
                return this;
            },
	    
	    // Crida al menu emergent de la aplicació

	    	popUp: function(e) {
	      		$("#pop").popup("open");
	    	},
		
	    // Funció que controla la correcte generació del llistat que apareix en pantalla

            pageShow:function (event) {
                if (!this.paginaPintada) {
                    this.paginaPintada = true;

                    var that = this;
                    _.defer(function () {
                        that.imprimirFeeds();
                    });
                }
            },
	    
	    // Definició del llistat on apareixeran les noticies
	    // generat mitjançant una funció que recorrerà el fitxer XML

            imprimirFeeds:function(){

                var that = this;
                var items = [];

                $.mobile.showPageLoadingMsg('a', 'Carregant llistat de noticies');

		//Accedim al fitxer on es llegiran els feeds
                $.get("file:///android_asset/www/prueba.xml", function(data) {
                    $.mobile.hidePageLoadingMsg();
		    
		    //Localitzam les diferents noticies el cream la funció que les tractarà
                    that.blogData= $(data).find("item").map(function(i, item) {

                        console.log('Impresió de la noticia: ' + $(item).find("title").text());
			
			//Cream el codi HTML de la noticia que posteriorment s'imprimirà i l'inserim a un vector
                        var $feed = $('<li> <a href="' + $(item).find("link").text() + '"> <h3>' + $(item).find("title").text() 
                            + '</h3> <p>' + $(item).find("description").text() + '</p> </a> </li>');
                        items.push($feed[0]);

                        return { 
                            url: $(item).find("link").text(), 
                            title: $(item).find("title").text(), 
                            body: $(item).find("description").text()
                        };
                    }).toArray();
		    //Refrescam la llista de noticies amb el recien generat vector de noticies
                    that.$feedsPerImprimir.html(items).listview('refresh');
                });



            }


        });
    });