define([
    'jquery',
    'Backbone',
    'parse',
    'views/Home/HomeView',
    'views/Home/LogInView',
    'views/CodiBarres/CodiBarresView',
    'views/LlistatPromocions/LlistatPromocionsView',
    'views/RssFeedReader/RssFeedReaderView',
    'views/LlistatHotel/LlistatHotelView',
    'views/LlistatHotel/LlistatRestaurantsView',
    'views/LlistatHotel/LlistatEquipamentView',
    'views/LlistatPromocions/LlistatReservesView',
    'jqm'
], function ($, Backbone, Parse, HomeView, LogInView, CodiBarresView, LlistatPromocionsView, RssFeedReaderView, LlistatHotelView, LlistatRestaurantsView, LlistatEquipamentView, LlistatReservesView) {
    'use strict';

    var AppRouter = Backbone.Router.extend({
      
      // Llistam les rutes accedibles desde qualsevol punt de l'aplicació

        routes:{
           "":"home",
            "pagament":"pagament",
            "promocions":"promocions",
            "blog":"blog",
            "infoHotel":"infoHotel",
            "infoRestaurants":"infoRestaurants",
            "infoEquipament":"infoEquipament",
            "infoPromocions":"infoPromocions",
            "infoReserves":"infoReserves",
            "menu":"menu"
        },

        initialize:function () {
           // Possibilitat d'inserir botó back en qualsevol punt de l'aplicació
            $('.back').live('click', function(event) {
               window.history.back();
                return false;
            });
            this.firstPage = true;
        },
	
	//La funció home tendrá un comportament definit per si l'usuari 
	// s'ha enregistrat o no

        home:function () {

            if (Parse.User.current()) {
                console.log('Home');
                this.changePage(new HomeView());
            } else {
                console.log('LogIn');
                this.changePage(new LogInView());
            }
        },
	
	// La resta de funcions es llimiten a obrir el marcador assignat

        pagament:function () {
            console.log('pagament');
            this.changePage(new CodiBarresView());
        },

        promocions:function () {
            console.log('promocions');
            this.changePage(new LlistatPromocionsView());
        },

        blog:function () {
            console.log('blog');
            this.changePage(new RssFeedReaderView());
        },

        infoHotel:function () {
            console.log('infoHotel');
            this.changePage(new LlistatHotelView());
        },

        infoRestaurants:function () {
            console.log('infoRestaurants');
            this.changePage(new LlistatRestaurantsView());
        },

        infoEquipament:function () {
            console.log('infoEquipament');
            this.changePage(new LlistatEquipamentView());
        },

        infoPromocions:function () {
            console.log('infoPromocions');
            this.changePage(new LlistatPromocionsView());
        },

        infoReserves:function () {
            console.log('infoReserves');
            this.changePage(new LlistatReservesView());
        },

        menu:function () {
            console.log('menu');
            this.changePage(new Menu());
        },
	
	// La funció principal del router es pageChange
	// Aquí definim el tractament de primer pàgina mitjançant jqmNavigator

        changePage:function (page) {

            var transition = $.mobile.defaultPageTransition;
            if (this.firstPage) {
                transition = 'none';
                this.firstPage = false;
                $.mobile.jqmNavigator.pushView(page, {transition: transition});
            }else{
                $.mobile.jqmNavigator.replaceView(page, {transition: transition});
            }
            
        }

    });

    return AppRouter;
});



